function y=ppval1(pp,np,nc,x)
	for k=2:np
		if x<pp(k,nc+1)
			y=polyval(pp(k-1,1:nc),x-pp(k-1,nc+1));
			return;
		end
	end
	y = polyval(pp(np,1:nc),x-pp(np,nc+1)); 
end

% value of piecewise polynomial pp at x
% one row per segment
% row = coefficients - startvalue of segment
function y=ppval(pp,x)
%% usage:
%% Values of piecewise polynomial pp at points x.
%% pp is a nxm matrix specifying n piecewise polynomials
%% of degree m-2. Each row of pp denotes one 
%% polynomial with m-1 coefficients and the left
%% edge x0 of the polynomials interval. Polynomial
%% values are calculated from the offset (x-x0).
	np=size(pp)(1);  		% Number of point
	nc=length(pp(1,:))-1; 	% Number of coefficients
	y=zeros(1,length(x));
	for k=1:length(x)
		y(k)=ppval1(pp,np,nc,x(k));
	end
end